using System.Runtime.Serialization;

namespace CoreLibrary.Exceptions
{
    /// <summary>
    /// Exception levée lorsqu'une opération est tentée alors que la partie n'a pas encore commencé.
    /// </summary>
    [Serializable]
    public class PartieNonCommenceeException : Exception
    {
        /// <summary>
        /// Initialise une nouvelle instance de la classe <see cref="PartieNonCommenceeException"/>.
        /// </summary>
        private const string messageDefaut = "La partie n'a pas encore commencée.";

        public PartieNonCommenceeException() : base(messageDefaut)
        { }

        public PartieNonCommenceeException(string message) : base(message)
        { }

        public PartieNonCommenceeException(string message, Exception exception) : base(message, exception)
        { }

        [Obsolete("This method is obsolete. Use alternative methods for data retrieval.", DiagnosticId = "SYSLIB0051")]
        protected PartieNonCommenceeException(SerializationInfo info, StreamingContext contexte) : base(info, contexte) { }

        [Obsolete("This method is obsolete. Use alternative methods for data retrieval.", DiagnosticId = "SYSLIB0051")]
        public override void GetObjectData(SerializationInfo info, StreamingContext context)
        {
            base.GetObjectData(info, context);
        }
    }
}
